using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace CSharpDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        private System.Windows.Forms.TextBox textBoxOut;
		private System.Windows.Forms.Button btnStart;
		private System.Windows.Forms.Button btnStop;
		private System.Windows.Forms.Timer timerDotNet;
		private ZylSoft.Timers.Timer timerZyl;
		private System.ComponentModel.IContainer components;
		public int DotNetCounter = 0;
		private System.Windows.Forms.Label label1;
        private ZylSoft.Timers.Timer timerMain;
		public int ZylCounter = 0;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.timerDotNet = new System.Windows.Forms.Timer(this.components);
            this.timerZyl = new ZylSoft.Timers.Timer(this.components);
            this.textBoxOut = new System.Windows.Forms.TextBox();
            this.btnStart = new System.Windows.Forms.Button();
            this.btnStop = new System.Windows.Forms.Button();
            this.label1 = new System.Windows.Forms.Label();
            this.timerMain = new ZylSoft.Timers.Timer(this.components);
            this.SuspendLayout();
            // 
            // timerDotNet
            // 
            this.timerDotNet.Interval = 1;
            this.timerDotNet.Tick += new System.EventHandler(this.timerDotNet_Tick);
            // 
            // timerZyl
            // 
            this.timerZyl.Cycled = true;
            this.timerZyl.Enabled = false;
            this.timerZyl.Interval = 1;
            this.timerZyl.Priority = System.Threading.ThreadPriority.Normal;
            this.timerZyl.RepeatCount = 0;
            this.timerZyl.Tick += new EventHandler<EventArgs>(this.timerZyl_Tick);
            // 
            // textBoxOut
            // 
            this.textBoxOut.Location = new System.Drawing.Point(8, 40);
            this.textBoxOut.Multiline = true;
            this.textBoxOut.Name = "textBoxOut";
            this.textBoxOut.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
            this.textBoxOut.Size = new System.Drawing.Size(292, 152);
            this.textBoxOut.TabIndex = 0;
            // 
            // btnStart
            // 
            this.btnStart.Location = new System.Drawing.Point(8, 208);
            this.btnStart.Name = "btnStart";
            this.btnStart.Size = new System.Drawing.Size(75, 23);
            this.btnStart.TabIndex = 1;
            this.btnStart.Text = "Start";
            this.btnStart.Click += new System.EventHandler(this.btnStart_Click);
            // 
            // btnStop
            // 
            this.btnStop.Location = new System.Drawing.Point(112, 208);
            this.btnStop.Name = "btnStop";
            this.btnStop.Size = new System.Drawing.Size(75, 23);
            this.btnStop.TabIndex = 2;
            this.btnStop.Text = "Stop";
            this.btnStop.Click += new System.EventHandler(this.btnStop_Click);
            // 
            // label1
            // 
            this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label1.Location = new System.Drawing.Point(10, 14);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(344, 13);
            this.label1.TabIndex = 3;
            this.label1.Text = "Tick events in 1 second (.NET Timer/ZylTimer):";
            // 
            // timerMain
            // 
            this.timerMain.Cycled = true;
            this.timerMain.Enabled = false;
            this.timerMain.Interval = 1000;
            this.timerMain.Priority = System.Threading.ThreadPriority.Normal;
            this.timerMain.RepeatCount = 0;
            this.timerMain.Tick += new EventHandler<EventArgs>(this.timerMain_Tick_1);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(312, 240);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.btnStop);
            this.Controls.Add(this.btnStart);
            this.Controls.Add(this.textBoxOut);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Name = "MainForm";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "ZylTimer.NET Demo";
            this.Closed += new System.EventHandler(this.MainForm_Closed);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

        // This delegate enables asynchronous calls for setting
        // the text property on a TextBox control.
        delegate void SetTextCallback(string text);


        private void Set_textBoxOut(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (this.textBoxOut.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Set_textBoxOut);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.textBoxOut.Text = text;
                this.textBoxOut.SelectionStart = textBoxOut.Text.Length;
                this.textBoxOut.SelectionLength = 0;
                this.textBoxOut.ScrollToCaret();
            }
        }

		private void timerMain_Tick(object sender, System.EventArgs e)
		{			

		}

		private void timerZyl_Tick(object sender, System.EventArgs e)
		{
			ZylCounter++;
		}

		private void timerDotNet_Tick(object sender, System.EventArgs e)
		{
			DotNetCounter++;
		}

		private void btnStart_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = true;
			timerZyl.Enabled = true;
			timerMain.Enabled = true;
		}

		private void btnStop_Click(object sender, System.EventArgs e)
		{
			timerDotNet.Enabled = false;
			timerZyl.Enabled = false;
			timerMain.Enabled = false;
			ZylCounter = 0;
			DotNetCounter = 0;
		}

		private void MainForm_Closed(object sender, System.EventArgs e)
		{
			if (timerZyl != null)
				timerZyl.Stop();
		}

        private void timerMain_Tick_1(object sender, EventArgs e)
        {
            Set_textBoxOut(textBoxOut.Text + DotNetCounter.ToString() + " / " +
                ZylCounter.ToString() + Environment.NewLine);
            ZylCounter = 0;
            DotNetCounter = 0;
        }
	}
}
